#include <windows.h>

writeError()
{
  char lastError[1024];
  FormatMessage(
                FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
                NULL,
                GetLastError(),
                MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                lastError,
                1024,
                NULL);
  OutputDebugString(lastError);
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
  HANDLE hSerial;
  DCB dcbSerialParams = {0};
  
  hSerial = CreateFile("COM2",
                       GENERIC_READ | GENERIC_WRITE,
                       0,
		               0,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL,
                       0);

  if(hSerial==INVALID_HANDLE_VALUE) {
    if(GetLastError()==ERROR_FILE_NOT_FOUND) {
      //serial port does not exist.
      OutputDebugString("Serial port not found.");
      writeError();
      return -1;
    }
    OutputDebugString("Could not open serial port.");
    writeError();
    return -1;
  }

  dcbSerialParams.DCBlength=sizeof(dcbSerialParams);
  if (!GetCommState(hSerial, &dcbSerialParams)) {
    OutputDebugString("error getting state");
    writeError();
  }
  dcbSerialParams.BaudRate=CBR_9600;
  dcbSerialParams.ByteSize=8;
  dcbSerialParams.StopBits=ONESTOPBIT;
  dcbSerialParams.Parity=NOPARITY;
  dcbSerialParams.fDtrControl=DTR_CONTROL_DISABLE;
  dcbSerialParams.fRtsControl=RTS_CONTROL_DISABLE;

  if(!SetCommState(hSerial, &dcbSerialParams)) {
    OutputDebugString("error setting serial port state");
    writeError();
    return -1;
  }

  while(1) {
    char szBuff[2] = {0};
    DWORD dwBytesRead = 0;
    OutputDebugString("reading...\n");
    if(!ReadFile(hSerial, szBuff, 1, &dwBytesRead, NULL)){
      OutputDebugString("error occurred during serial read\n");
      writeError();
      continue;
    }
    
    if(szBuff[0] == 'I') {
	  OutputDebugString("ON\n");
      EscapeCommFunction(hSerial, SETDTR);
    }

	//TODO: Set a timeout and lower DTR when 1) no byte was received and 2) an unknown byte was received
    if(szBuff[0] == 'O') {
	  OutputDebugString("off\n");
      EscapeCommFunction(hSerial, CLRDTR);
    }
  }

  //TODO: How do we get here?
  CloseHandle(hSerial);
  return 0;
}
